Index: cpp/frams/util/3d.cpp
===================================================================
--- cpp/frams/util/3d.cpp	(revision 171)
+++ cpp/frams/util/3d.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/3d.h
===================================================================
--- cpp/frams/util/3d.h	(revision 171)
+++ cpp/frams/util/3d.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/advlist.cpp
===================================================================
--- cpp/frams/util/advlist.cpp	(revision 171)
+++ cpp/frams/util/advlist.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/advlist.h
===================================================================
--- cpp/frams/util/advlist.h	(revision 171)
+++ cpp/frams/util/advlist.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/callbacks.cpp
===================================================================
--- cpp/frams/util/callbacks.cpp	(revision 171)
+++ cpp/frams/util/callbacks.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/callbacks.h
===================================================================
--- cpp/frams/util/callbacks.h	(revision 171)
+++ cpp/frams/util/callbacks.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/extvalue.cpp
===================================================================
--- cpp/frams/util/extvalue.cpp	(revision 171)
+++ cpp/frams/util/extvalue.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/extvalue.h
===================================================================
--- cpp/frams/util/extvalue.h	(revision 171)
+++ cpp/frams/util/extvalue.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/hashtable.cpp
===================================================================
--- cpp/frams/util/hashtable.cpp	(revision 171)
+++ cpp/frams/util/hashtable.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/hashtable.h
===================================================================
--- cpp/frams/util/hashtable.h	(revision 171)
+++ cpp/frams/util/hashtable.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/list.cpp
===================================================================
--- cpp/frams/util/list.cpp	(revision 171)
+++ cpp/frams/util/list.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/list.h
===================================================================
--- cpp/frams/util/list.h	(revision 171)
+++ cpp/frams/util/list.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/multimap.cpp
===================================================================
--- cpp/frams/util/multimap.cpp	(revision 171)
+++ cpp/frams/util/multimap.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/multimap.h
===================================================================
--- cpp/frams/util/multimap.h	(revision 171)
+++ cpp/frams/util/multimap.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/multirange.cpp
===================================================================
--- cpp/frams/util/multirange.cpp	(revision 171)
+++ cpp/frams/util/multirange.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/multirange.h
===================================================================
--- cpp/frams/util/multirange.h	(revision 171)
+++ cpp/frams/util/multirange.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/rndutil.cpp
===================================================================
--- cpp/frams/util/rndutil.cpp	(revision 171)
+++ cpp/frams/util/rndutil.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/rndutil.h
===================================================================
--- cpp/frams/util/rndutil.h	(revision 171)
+++ cpp/frams/util/rndutil.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/sstring.cpp
===================================================================
--- cpp/frams/util/sstring.cpp	(revision 171)
+++ cpp/frams/util/sstring.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/sstring.h
===================================================================
--- cpp/frams/util/sstring.h	(revision 171)
+++ cpp/frams/util/sstring.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/sstringutils.cpp
===================================================================
--- cpp/frams/util/sstringutils.cpp	(revision 171)
+++ cpp/frams/util/sstringutils.cpp	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/sstringutils.h
===================================================================
--- cpp/frams/util/sstringutils.h	(revision 171)
+++ cpp/frams/util/sstringutils.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/statrick.h
===================================================================
--- cpp/frams/util/statrick.h	(revision 171)
+++ cpp/frams/util/statrick.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/util/usertags.h
===================================================================
--- cpp/frams/util/usertags.h	(revision 171)
+++ cpp/frams/util/usertags.h	(revision 197)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK.
-// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 1999-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 